diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
index 25b6198b7..9c5fcec2e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
@@ -17,6 +17,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.util.helper.LightIndexHelper;
+import org.jetbrains.annotations.NotNull;
 
 import static net.minecraft.client.Minecraft.HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
 
@@ -63,7 +64,7 @@ public class HudComponentHotbar extends HudComponentMovable {
 
     // Offset anchors to account for the selector dots depending on orientation
     @Override
-    public int getDisplayedAnchorX(ComponentAnchor anchor) {
+    public int getDisplayedAnchorX(@NotNull ComponentAnchor anchor) {
         int xAnchor = super.getDisplayedAnchorX(anchor);
         if (!this.isVertical()) {
             if (anchor.xPosition == 0.0f) {
@@ -76,7 +77,7 @@ public class HudComponentHotbar extends HudComponentMovable {
     }
 
     @Override
-    public int getDisplayedAnchorY(ComponentAnchor anchor) {
+    public int getDisplayedAnchorY(@NotNull ComponentAnchor anchor) {
         int yAnchor = super.getDisplayedAnchorY(anchor);
         if (this.isVertical()) {
             if (anchor.yPosition == 0.0f) {
@@ -175,7 +176,7 @@ public class HudComponentHotbar extends HudComponentMovable {
     }
 
     @Override
-    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+    public void renderPreview(Gui gui, @NotNull Layout layout, int xSizeScreen, int ySizeScreen) {
         int x = layout.getComponentX(this, xSizeScreen);
         int y = layout.getComponentY(this, ySizeScreen);
         boolean isVertical = this.isVertical();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
index a9b59b7a7..65e7dc69a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
@@ -17,6 +17,7 @@ import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -203,7 +204,7 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
         drawLines(lines, x, y);
     }
 
-    private void drawLines(List<RenderLine> lines, int x, int y) {
+    private void drawLines(@NotNull List<RenderLine> lines, int x, int y) {
         if (lines.isEmpty()) return;
 
         int lineHeight = 10;
@@ -212,12 +213,12 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
         float yMult = GameSettings.VERTICAL_INFO_TEXT_ALIGNMENT.value.multiplier;
 
         int padding = 2;
-        int startY = y + padding + (int) ((this.getDisplayedYSize() - (padding * 2) - totalHeight) * yMult);
+        int startY = y + padding + (int) ((this.getBaseYSize() - (padding * 2) - totalHeight) * yMult);
 
         for (int i = 0; i < lines.size(); i++) {
             RenderLine line = lines.get(i);
             int currentY = startY + (i * lineHeight);
-            drawAlignedString(line.text, x, currentY, this.getDisplayedXSize(), line.color);
+            drawAlignedString(line.text, x, currentY, this.getBaseXSize(), line.color);
         }
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
index 455b1e9a7..ae1b12c06 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
@@ -5,8 +5,6 @@ import net.minecraft.client.console.LogMessageReceiver;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
-import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
-import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
@@ -14,7 +12,6 @@ import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.net.command.TextFormatting;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.HashMap;
@@ -74,6 +71,13 @@ public class HudComponentLog extends HudComponentMovable {
         return GameSettings.DEVELOPER_MODE.value;
     }
 
+    private void drawAlignedString(@NotNull FontRenderer sr, String text, int boxX, int boxY, int boxWidth, int argb) {
+        int textWidth = sr.stringWidth(text);
+        float xMult = GameSettings.HORIZONTAL_LOG_TEXT_ALIGNMENT.value.multiplier;
+        int renderX = boxX + PADDING + (int) ((boxWidth - (PADDING * 2) - textWidth) * xMult);
+        sr.render(text, renderX, boxY).setShadow().setColor(argb).call();
+    }
+
     @Override
     public void render(final @NotNull HudIngame hud, final int xSizeScreen, final int ySizeScreen, final float partialTick) {
         if (!this.callbackAdded) {
@@ -127,14 +131,7 @@ public class HudComponentLog extends HudComponentMovable {
             opacities[i] = this.logEntries.get(i).getOpacity();
         }
 
-        @Nullable ComponentAnchor anchor = null;
-        if (this.layout instanceof LayoutAbsolute layoutAbsolute) {
-            anchor = layoutAbsolute.getAnchor();
-        } else if (this.layout instanceof LayoutSnap layoutSnap) {
-            anchor = layoutSnap.getAnchor();
-        }
-
-        render(mc.font, x, y, messages, opacities, anchor);
+        render(mc.font, x, y, messages, opacities);
     }
 
     @Override
@@ -149,30 +146,22 @@ public class HudComponentLog extends HudComponentMovable {
             this.preludes.get(LogMessage.Level.ERROR) + "This is an error line!",
         };
 
-        @Nullable ComponentAnchor anchor = null;
-        if (layout instanceof LayoutAbsolute layoutAbsolute) {
-            anchor = layoutAbsolute.getAnchor();
-        } else if (layout instanceof LayoutSnap layoutSnap) {
-            anchor = layoutSnap.getAnchor();
-        }
-
-        render(mc.font, x, y, lines, new float[]{1.0f, 1.0f, 1.0f, 1.0f}, anchor);
+        render(mc.font, x, y, lines, new float[]{1.0f, 1.0f, 1.0f, 1.0f});
     }
 
-    private void render(final @NotNull FontRenderer sr, final int x, final int y, final @NotNull String @NotNull [] lines, final float @NotNull [] opacities, final @Nullable ComponentAnchor anchor) {
+    private void render(final @NotNull FontRenderer sr, final int x, final int y, final @NotNull String @NotNull [] lines, final float @NotNull [] opacities) {
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-        for (int i = 0; i < lines.length; i++) {
-            @NotNull String line = lines[i];
 
-            final int lineWidth = sr.stringWidth(line);
-            if (anchor == null || anchor == ComponentAnchor.TOP_LEFT || anchor == ComponentAnchor.CENTER_LEFT || anchor == ComponentAnchor.BOTTOM_LEFT) {
-                sr.render(line, x + PADDING, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int) (opacities[i] * 0xFF) << 24)).call();
-            } else if (anchor == ComponentAnchor.TOP_CENTER || anchor == ComponentAnchor.CENTER || anchor == ComponentAnchor.BOTTOM_CENTER) {
-                sr.render(line, x + PADDING + WIDTH / 2 - lineWidth / 2, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int) (opacities[i] * 0xFF) << 24)).call();
-            } else {
-                sr.render(line, x + PADDING + WIDTH - lineWidth, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int) (opacities[i] * 0xFF) << 24)).call();
-            }
+        float yMult = GameSettings.VERTICAL_LOG_TEXT_ALIGNMENT.value.multiplier;
+        int totalHeight = lines.length * LINE_HEIGHT;
+        int startY = y + PADDING + (int) ((this.getBaseYSize() - (PADDING * 2) - totalHeight) * yMult);
+
+        for (int i = 0; i < lines.length; i++) {
+            String line = lines[i];
+            int currentY = startY + (i * LINE_HEIGHT);
+            int color = 0x00_FF_FF_FF + ((int) (opacities[i] * 0xFF) << 24);
+            drawAlignedString(sr, line, x, currentY, this.getBaseXSize(), color);
         }
         GLRenderer.disableState(State.BLEND);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java
index 37d25ac4d..99f7b22e6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java
@@ -9,6 +9,7 @@ import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.sound.SoundRepository;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -25,7 +26,13 @@ public class HudComponentSubtitles extends HudComponentMovable {
 
     @Override
     public boolean isEnabled() {
-        return GameSettings.SUBTITLES.value;
+        // Keep subtitles editable in HUD editor even when hidden in-game.
+        return true;
+    }
+
+    @Override
+    public boolean isPreviewTranslucent() {
+        return !isVisible();
     }
 
     @Override
@@ -35,6 +42,9 @@ public class HudComponentSubtitles extends HudComponentMovable {
 
     @Override
     public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+
+        renderTranslucency();
+
         List<SubtitleTracker.SubtitleEntry> example = new ArrayList<>();
         example.add(new SubtitleTracker.SubtitleEntry(SoundRepository.SOUNDS.getSoundEvent("mob.wolf.whine"), 0, 0, 0));
         example.add(new SubtitleTracker.SubtitleEntry(SoundRepository.SOUNDS.getSoundEvent("random.drr"), 0, 0, 0));
@@ -42,19 +52,22 @@ public class HudComponentSubtitles extends HudComponentMovable {
         drawChat(gui, example, xSizeScreen, ySizeScreen, 0);
     }
 
-    public void drawChat(Gui gui, List<SubtitleTracker.SubtitleEntry> subtitleEntries, int xSizeScreen, int ySizeScreen, float partialTick)
+    public void drawChat(Gui gui, @NotNull List<SubtitleTracker.SubtitleEntry> subtitleEntries, int xSizeScreen, int ySizeScreen, float partialTick)
     {
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
-        int width = getDisplayedXSize();
-        int height = getDisplayedYSize();
-        int xRight = x + width;
-        int yBottom = y + height;
+        int width = getBaseXSize();
+        int height = getBaseYSize();
         int messagesToShow = height/10;
         boolean ignoreFadeout = false;
+        int visibleEntries = Math.min(subtitleEntries.size(), messagesToShow);
+        int rowHeight = 9;
+        int blockHeight = visibleEntries * rowHeight;
+        float xMult = GameSettings.HORIZONTAL_SUBTITLE_TEXT_ALIGNMENT.value.multiplier;
+        float yMult = GameSettings.VERTICAL_SUBTITLE_TEXT_ALIGNMENT.value.multiplier;
 
         int maxMessageWidth = 0;
-        for (int i = 0; i < subtitleEntries.size() && i < messagesToShow; i++)
+        for (int i = 0; i < visibleEntries; i++)
         {
             SubtitleTracker.SubtitleEntry entry = subtitleEntries.get(i);
             if (entry.soundEvent == null) {
@@ -66,10 +79,14 @@ public class HudComponentSubtitles extends HudComponentMovable {
             }
         }
         maxMessageWidth += mc.font.stringWidth("<") + mc.font.stringWidth(">");
+        byte xPad = 3;
+        int boxWidth = maxMessageWidth + xPad * 2;
+        int blockLeft = x + Math.round(Math.max(0, width - boxWidth) * xMult);
+        int blockTop = y + Math.round(Math.max(0, height - blockHeight) * yMult);
 
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-        for (int i = 0; i < subtitleEntries.size() && i < messagesToShow; i++)
+        for (int i = 0; i < visibleEntries; i++)
         {
             SubtitleTracker.SubtitleEntry entry = subtitleEntries.get(i);
             if (entry.soundEvent == null) {
@@ -89,25 +106,20 @@ public class HudComponentSubtitles extends HudComponentMovable {
             }
             fadeAmount *= fadeAmount;
             int alpha = (int) (255D * fadeAmount);
-            if (ignoreFadeout)
-            {
-                alpha = 255;
-            }
             if (alpha > 0)
             {
-                byte xPad = 3;
-                int y2 = -i * 9 - 8;
+                int renderY = blockTop + ((visibleEntries - 1 - i) * rowHeight);
                 final String subtitle = entry.soundEvent.getSubtitleTranslated();
                 if (subtitle != null) {
-                    gui.drawRect(xRight - maxMessageWidth - xPad * 2, yBottom + y2 - 1, xRight, yBottom + y2 + 8, alpha / 2 << 24);
+                    gui.drawRect(blockLeft, renderY - 1, blockLeft + boxWidth, renderY + 8, alpha / 2 << 24);
                     GLRenderer.enableState(State.BLEND);
-                    mc.font.renderCentered(subtitle, xRight - (maxMessageWidth) / 2 - xPad, yBottom + y2).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
+                    mc.font.renderCentered(subtitle, blockLeft + boxWidth / 2, renderY).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
                     if (mc.thePlayer != null) {
                         final double sin = Math.sin(entry.getRelativeAngle(mc.thePlayer) + Math.PI/2);
                         if (sin > 0.7) {
-                            mc.font.render("<", xRight - maxMessageWidth - xPad, yBottom + y2).setColor(0xFFFFFF + (alpha << 24)).call();
+                            mc.font.render("<", blockLeft + xPad / 2, renderY).setColor(0xFFFFFF + (alpha << 24)).call();
                         } else if (sin < -0.7) {
-                            mc.font.render(">", xRight - mc.font.stringWidth(">") - xPad/2, yBottom + y2).setColor(0xFFFFFF + (alpha << 24)).call();
+                            mc.font.render(">", blockLeft + boxWidth - mc.font.stringWidth(">") - xPad / 2, renderY).setColor(0xFFFFFF + (alpha << 24)).call();
                         }
                     }
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
index 7e410dbd0..6ee04f34d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
@@ -21,9 +21,11 @@ public class HudComponents {
     public static String DEFAULT_LAYOUT = null;
     public static final @Nullable HudComponents INSTANCE = new HudComponents();
 
-    // Absolute components
+    public static final @NotNull HudComponentChatInput CHAT_INPUT = register(
+        new HudComponentChatInput("chat_input", HudComponentChat.DEFAULT_CHAT_WIDTH, 14, new LayoutAbsolute(0.0f, 1.0f, ComponentAnchor.BOTTOM_LEFT, 0, 0))
+    );
     public static final @NotNull HudComponentHotbar HOTBAR = register(
-        new HudComponentHotbar("hotbar", new LayoutAbsolute(0.5f, 1.0f, ComponentAnchor.BOTTOM_CENTER, 0, -2))
+        new HudComponentHotbar("hotbar", new LayoutAbsolute(0.5f, 1.0f, ComponentAnchor.BOTTOM_CENTER, 0, 0))
             .addAttachedOption(GameSettings.VERTICAL_HOT_BAR, () -> new BooleanOptionComponent(GameSettings.VERTICAL_HOT_BAR))
     );
     public static final @NotNull HudComponentCrosshair CROSSHAIR = register(
@@ -31,13 +33,15 @@ public class HudComponents {
     );
     public static final @NotNull HudComponentSubtitles SUBTITLES = register(
         new HudComponentSubtitles("subtitles_box", 100, 50, new LayoutAbsolute(1.0f, 0.75f, ComponentAnchor.BOTTOM_RIGHT))
+            .addAttachedOption(GameSettings.SUBTITLES, () -> new BooleanOptionComponent(GameSettings.SUBTITLES))
+            .addAttachedOption(GameSettings.HORIZONTAL_SUBTITLE_TEXT_ALIGNMENT, () -> new ToggleableOptionComponent<>(GameSettings.HORIZONTAL_SUBTITLE_TEXT_ALIGNMENT))
+            .addAttachedOption(GameSettings.VERTICAL_SUBTITLE_TEXT_ALIGNMENT, () -> new ToggleableOptionComponent<>(GameSettings.VERTICAL_SUBTITLE_TEXT_ALIGNMENT))
     );
     public static final @NotNull HudComponentLog LOG = register(
         new HudComponentLog("log", new LayoutAbsolute(1.0f, 0.0f, ComponentAnchor.TOP_RIGHT))
+            .addAttachedOption(GameSettings.HORIZONTAL_LOG_TEXT_ALIGNMENT, () -> new ToggleableOptionComponent<>(GameSettings.HORIZONTAL_LOG_TEXT_ALIGNMENT))
+            .addAttachedOption(GameSettings.VERTICAL_LOG_TEXT_ALIGNMENT, () -> new ToggleableOptionComponent<>(GameSettings.VERTICAL_LOG_TEXT_ALIGNMENT))
     );
-
-    // public static final @NotNull HudComponentArmorDurability ARMOR_DURABILITY = register(new HudComponentArmorDurability("armor_durability", new LayoutAbsolute(0.0f, 1.0f, ComponentAnchor.BOTTOM_LEFT)));
-
     public static final @NotNull HudComponentInfoOverlay INFO_OVERLAY = register(
         new HudComponentInfoOverlay("info_overlay", new LayoutAbsolute(0.0f, 0.0f, ComponentAnchor.TOP_LEFT))
             .addAttachedOption(GameSettings.HORIZONTAL_INFO_TEXT_ALIGNMENT, () -> new ToggleableOptionComponent<>(GameSettings.HORIZONTAL_INFO_TEXT_ALIGNMENT))
@@ -54,6 +58,12 @@ public class HudComponents {
     );
 
     // Snapped components
+    public static final @NotNull HudComponentChat CHAT = register(
+        new HudComponentChat("chat", HudComponentChat.DEFAULT_CHAT_WIDTH, 110, new LayoutSnap(CHAT_INPUT, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT, 0, -50))
+            .addAttachedOption(GameSettings.chatVisibility, () -> new ToggleableOptionComponent<>(GameSettings.chatVisibility))
+            .addAttachedOption(GameSettings.HORIZONTAL_CHAT_TEXT_ALIGNMENT, () -> new ToggleableOptionComponent<>(GameSettings.HORIZONTAL_CHAT_TEXT_ALIGNMENT))
+            .addAttachedOption(GameSettings.VERTICAL_CHAT_TEXT_ALIGNMENT, () -> new ToggleableOptionComponent<>(GameSettings.VERTICAL_CHAT_TEXT_ALIGNMENT))
+    );
     public static final @NotNull HudComponentDynamicTooltip DYNAMIC_TOOLTIP = register(
         new HudComponentDynamicTooltip("dynamic_tooltip", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_CENTER, ComponentAnchor.BOTTOM_CENTER, 0, -29))
             .addAttachedOption(GameSettings.HIDE_DYNAMIC_TOOLTIP, () -> new BooleanOptionComponent(GameSettings.HIDE_DYNAMIC_TOOLTIP))
@@ -121,6 +131,10 @@ public class HudComponents {
             .addAttachedOption(GameSettings.FLIP_HELD_ITEM_COUNT, () -> new BooleanOptionComponent(GameSettings.FLIP_HELD_ITEM_COUNT))
     );
 
+    static {
+        CHAT_INPUT.linkChat(CHAT);
+    }
+
     public static <T extends HudComponent> T register(T component) {
         if(INSTANCE == null) throw new IllegalStateException("HudComponents not initialized, Instance is null");
         INSTANCE.components.add(component);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
index b6da0e1e2..fe34da949 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
@@ -38,12 +38,14 @@ public class LayoutAbsolute extends Layout {
 
     @Override
     public int getComponentX(@NotNull HudComponent component, int xSizeScreen) {
-        return (int) (this.xPosition * xSizeScreen) - component.getTrueAnchorX(this.anchor) + this.xOffset;
+        int padding = (int) GameSettings.SCREEN_PADDING.value.floatValue();
+        return padding + (int) (this.xPosition * (xSizeScreen - padding * 2)) - component.getTrueAnchorX(this.anchor) + this.xOffset;
     }
 
     @Override
     public int getComponentY(@NotNull HudComponent component, int ySizeScreen) {
-        return (int) (this.yPosition * ySizeScreen) - component.getTrueAnchorY(this.anchor) + this.yOffset;
+        int padding = (int) GameSettings.SCREEN_PADDING.value.floatValue();
+        return padding + (int) (this.yPosition * (ySizeScreen - padding * 2)) - component.getTrueAnchorY(this.anchor) + this.yOffset;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
index d0cb4cb83..10e4e5d20 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
@@ -4,6 +4,7 @@ import net.minecraft.client.gui.ScreenHudEditor;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
 import net.minecraft.client.gui.hud.component.HudComponent;
 import net.minecraft.client.gui.hud.component.HudComponents;
+import net.minecraft.client.option.GameSettings;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -41,14 +42,15 @@ public class LayoutSnap extends Layout {
     @Override
     public int getComponentX(@NotNull HudComponent component, int xSizeScreen) {
         if (this.parent == null) {
-            return (int) (xSizeScreen * this.parentAnchor.xPosition) - component.getTrueAnchorX(this.anchor) + this.xOffset;
+            int padding = (int) GameSettings.SCREEN_PADDING.value.floatValue();
+            return padding + (int) ((xSizeScreen - padding * 2) * this.parentAnchor.xPosition) - component.getTrueAnchorX(this.anchor) + this.xOffset;
         }
 
         int posX = this.parent.getLayout().getComponentX(this.parent, xSizeScreen)
                 - component.getTrueAnchorX(this.anchor)
                 + this.parent.getTrueAnchorX(this.parentAnchor);
 
-        if (!this.parent.isVisible() && !(mc.currentScreen instanceof ScreenHudEditor)) {
+        if (component.isSnapToFill() && !this.parent.isVisible() && !(mc.currentScreen instanceof ScreenHudEditor)) {
             float collapseDirection = this.anchor.xPosition - this.parentAnchor.xPosition;
             posX += (int) (collapseDirection * this.parent.getTrueXSize());
         } else {
@@ -61,14 +63,15 @@ public class LayoutSnap extends Layout {
     @Override
     public int getComponentY(@NotNull HudComponent component, int ySizeScreen) {
         if (this.parent == null) {
-            return (int) (ySizeScreen * this.parentAnchor.yPosition) - component.getTrueAnchorY(this.anchor) + this.yOffset;
+            int padding = (int) GameSettings.SCREEN_PADDING.value.floatValue();
+            return padding + (int) ((ySizeScreen - padding * 2) * this.parentAnchor.yPosition) - component.getTrueAnchorY(this.anchor) + this.yOffset;
         }
 
         int posY = this.parent.getLayout().getComponentY(this.parent, ySizeScreen)
                 - component.getTrueAnchorY(this.anchor)
                 + this.parent.getTrueAnchorY(this.parentAnchor);
 
-        if (!this.parent.isVisible() && !(mc.currentScreen instanceof ScreenHudEditor)) {
+        if (component.isSnapToFill() && !this.parent.isVisible() && !(mc.currentScreen instanceof ScreenHudEditor)) {
             float collapseDirection = this.anchor.yPosition - this.parentAnchor.yPosition;
             posY += (int) (collapseDirection * this.parent.getTrueYSize());
         } else {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanToggleComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanToggleComponent.java
new file mode 100644
index 000000000..7070ed313
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanToggleComponent.java
@@ -0,0 +1,81 @@
+package net.minecraft.client.gui.options.components;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.SwitchElement;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.function.BooleanSupplier;
+import java.util.function.Consumer;
+
+public class BooleanToggleComponent
+    extends ButtonComponent
+{
+    private final BooleanSupplier getter;
+    private final Consumer<Boolean> setter;
+    private final boolean defaultValue;
+    private final SwitchElement button;
+
+    public BooleanToggleComponent(String translationKey, boolean defaultValue, @NotNull BooleanSupplier getter, Consumer<Boolean> setter, @Nullable String tooltipTranslationKey) {
+        super(translationKey, tooltipTranslationKey);
+
+        this.getter = getter;
+        this.setter = setter;
+        this.defaultValue = defaultValue;
+        this.button = new SwitchElement(0, 0, 0, 150, 20, getter.getAsBoolean(), "", "");
+        updateButton();
+    }
+
+    public BooleanToggleComponent(String translationKey, boolean defaultValue, BooleanSupplier getter, Consumer<Boolean> setter) {
+        this(translationKey, defaultValue, getter, setter, null);
+    }
+
+    private void updateButton() {
+        this.button.setOn(this.getter.getAsBoolean());
+        I18n i18n = I18n.getInstance();
+        this.button.displayString = this.getter.getAsBoolean()
+            ? i18n.translateKey("options.on")
+            : i18n.translateKey("options.off");
+    }
+
+    @Override
+    public void resetValue() {
+        this.setter.accept(this.defaultValue);
+        updateButton();
+    }
+
+    @Override
+    public void init(Minecraft mc) {
+        updateButton();
+    }
+
+    @Override
+    public boolean isDefault() {
+        return this.getter.getAsBoolean() == this.defaultValue;
+    }
+
+    @Override
+    protected void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
+        this.setter.accept(!this.getter.getAsBoolean());
+        updateButton();
+    }
+
+    @Override
+    protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY) {
+        super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
+
+        this.button.xPosition = x + relativeButtonX;
+        this.button.yPosition = y + relativeButtonY;
+        this.button.width = buttonWidth;
+        this.button.height = buttonHeight;
+
+        this.button.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            assert mc.currentScreen != null;
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+    }
+}
